set ns "region"
catch { ${ns}::uninstall }


namespace eval $ns {

  variable title "New region"
  variable version "0.1"
  variable author ""
  variable editor "kns @ RusNet"

  variable chflag [namespace tail [namespace current]]

  variable trigger "!"
  variable pubflag "-|-"

  variable cmd

  variable datafile "data/${chflag}.dat"
  variable data [list]

## ,     .
   variable binds [list "region" ""]

##     .
  variable delay 10

##     ? 1 - , 0 - 
  variable fastoutput "1"

  setudef flag $chflag

  foreach tmp $binds {
    bind pub $pubflag "${trigger}${tmp}" [namespace current]::pubq
    bind msg $pubflag "${trigger}${tmp}" [namespace current]::msgq
  }


    proc init {} {
        variable datafile
        variable data

        if {![file exists $datafile]} {
            putlog "\00304Error\003: Datafile (${datafile}) is not exists"
            return 0
        } else {
            if {[catch {set fileio [open $datafile r]} r]} {
            putlog "\00304Error\003: $r"
            return 0
            }

            while {![eof $fileio]} {
                set line [split [gets $fileio] "#"]
                if {[llength $line]} {
#                    lappend data [regexp -all -inline -- {\d+} [lindex $line 0]] [lindex $line 1]
                    lappend data [split [lindex $line 0] ","] [lindex $line 1]
                }
            }
            close $fileio

            return 1
        }
    }

#   rules.tcl by CoolCold

    proc putfast {text} {
        append text "\n"
        putdccraw 0 [string length $text] $text
    }


    proc putserv {text} {
        variable fastoutput

        if {$fastoutput eq "1"} {
            putfast $text
        } else {
            ::putserv $text
        }
    }

    proc stripspaces { ustr } {
        regsub -all -- {\s+} $ustr { } ustr
        set ustr [string trim $ustr]
        return $ustr
    }

    proc msgq { unick uhost uhand ustr } {
        pubq $unick $uhost $uhand $uhost $ustr
    }

    proc pubq { unick uhost uhand uchan ustr } {
        variable chflag
        variable usage
        variable delay
        variable cmd

        variable data

        if {[validchan $uchan]} {
            if {![channel get $uchan $chflag] && ![matchattr $uhand n]} { return 0 }
        }
        if {[info exists cmd(last,${uchan})]} {
            set ld [expr {[clock seconds] - $cmd(last,${uchan})}]
            if {$ld < [expr {$delay - 1}]} {
                putserv "NOTICE $unick :  ,    [expr {$delay - $ld}] ."
                return 0
            }
        }

        set cmd(last,${uchan}) [clock seconds]

        set ustr [lindex [split [stripspaces [stripcodes bcru $ustr]]]]

        putlog ":: $chflag :: (${uchan}/${unick}) :: $ustr"

        set reg ""

        if {[string is digit -strict $ustr]} {
            foreach {n r} $data {
                if {[lsearch -exact $n $ustr] != -1} {
                    set reg "\00306[join $n "\003,\00306 "]\003:\00305 $r\003."
                    break
                }
            }
            unset n r
        } elseif {$ustr ne ""} {
            foreach {n r} $data {
                if {[string match -nocase "*${ustr}*" $r]} {
                    set reg "\00306[join $n "\003,\00306 "]\003:\00305 $r\003."
                    break
                }
            }
            unset n r
        }

        if {$reg eq ""} {
            set reg "\00304Err\003:   ."
        }

        if {[validchan $uchan]} {
            if {([string first "c" [lindex [getchanmode $uchan] 0]] != -1) || \
                    ![channel get $uchan usecolors]} {
                set reg [stripcodes "c" $reg]
            }
        } else {
            set uchan $unick
        }

        putserv "PRIVMSG $uchan :$reg"

        unset reg ustr
        return
    }


    bind evnt - prerehash [namespace current]::uninstall
    proc uninstall {args} {
        foreach bind [binds "[namespace current]::*"] {
            catch {
                unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]
            }
        }
        namespace delete [namespace current]
    }

    if {![init]} {
        uninstall
        return -code error "\00304\003:       "
    }

   return -code ok "$title script v$version by \002$author\002 edited by \002$editor\002 loaded"
}